
class bezierSpline extends genericSplineCurve {
		
	
	public bezierSpline() {
		
		super();
		nbPointsToCopyToCloseCurve = 0;	

	}
	
	
	public void computeSplineCurve() {

		double x,y,t;
		int p[][] = new int[4][2];
		double b[] = new double[4];
				
		intermediatePoints.removeAllElements();
		intermediatePoints.trimToSize();
		nbPoints=0;
			
		if (nbControlPoints>=4) {
			for(int j=0;j<nbControlPoints-3;j+=3)  {
				for(int k=j;k<j+4;k++) {
		   		p[k-j][0] = (int)(((coord2D)(controlPoints.elementAt(k))).x);
	    		p[k-j][1] = (int)(((coord2D)(controlPoints.elementAt(k))).y);				
				}
				for(int i=0;i<=nbPointsPerSegment;i++) {				
					t = (double)i/(double)nbPointsPerSegment;						
					b[0] = (1-t)*(1-t)*(1-t);
					b[1] = 3*t*(1-t)*(1-t);
					b[2] = 3*t*t*(1-t);
					b[3] = t*t*t;					
					x = b[0]*p[0][0]+b[1]*p[1][0]+b[2]*p[2][0]+b[3]*p[3][0];	
					y = b[0]*p[0][1]+b[1]*p[1][1]+b[2]*p[2][1]+b[3]*p[3][1];	
					intermediatePoints.addElement(new coord2D(x,y));
					nbPoints++;
				}
			}
		}
			
	}
	
	
}