class cubicUniformBSpline extends genericSplineCurve {
		
	
	public cubicUniformBSpline() {
		
		super();
		nbPointsToCopyToCloseCurve = 3;	
		
	}

	
	public void computeSplineCurve() {

		double x,y,t;
		int p[][] = new int[4][2];
		double u[] = new double[4];
		
		intermediatePoints.removeAllElements();
		intermediatePoints.trimToSize();
		nbPoints=0;
			
		if (nbControlPoints>=4) {
			for(int j=0;j<nbControlPoints-3;j++)  {
				for(int k=j;k<j+4;k++) {
		   		p[k-j][0] = (int)(((coord2D)(controlPoints.elementAt(k))).x);
	    		p[k-j][1] = (int)(((coord2D)(controlPoints.elementAt(k))).y);				
				}
								
				for(int i=0;i<=nbPointsPerSegment;i++) {				
					t = (double)i/(double)nbPointsPerSegment;				
					u[0] = 1.0/6.0 * ((1-t)*(1-t)*(1-t));
					u[1] = 1.0/6.0 * (1+3*(1-t)+3*(1-t)*(1-t)-3*(1-t)*(1-t)*(1-t));
					u[2] = 1.0/6.0 * (1+3*t+3*t*t-3*t*t*t);
					u[3] = 1.0/6.0 * (t*t*t);
					x = u[0]*p[0][0]+u[1]*p[1][0]+u[2]*p[2][0]+u[3]*p[3][0];	
					y = u[0]*p[0][1]+u[1]*p[1][1]+u[2]*p[2][1]+u[3]*p[3][1];	
					intermediatePoints.addElement(new coord2D(x,y));
					nbPoints++;
				}
			}
		}
			
	}
	
	
}